                
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  x_pin = 0       'MEMSIC X
obj graph : "rjo_graph"
    timer   : "Timer"
var
  long    xG,yG,levelx  

                    
pub start|i
  graph.start
  waitcnt(clkfreq + cnt)
  
 ' waitcnt(clkfreq/10 + cnt)
  'graph.plot(0)

  doG
pub doG | i,xgTot,aveXg,maxXg,minXG,mph,runcor,ii,elapsedtix,iii,iiii,temptix,xGAccel
  timer.start
  xG:=0
  mph:=0
  minXG:=10_000_000
  maxXg:=-10_000_000
  xgTot:=0
  calibratex(x_pin)
  waitcnt(clkfreq/10 + cnt)
  repeat 20
    xg:= readGforce(x_pin)
    xgtot:=xgtot+xg
  avexg:=xgtot/20

  xgTot:=0
  
  I:=0
  temptix:=0
  timer.run

  repeat 
    i++                       'unused counter
    xG:= readGforce(x_pin)
    xg:=10*((xg-avexg)/10)             'truncate xg     
    if xg=>maxXg
      maxXg:=xG
    if xG=< MinXg
      MinXg:=xG    
    xGtot:=xgtot + (xG * elapsedtix)

    mph:=(xgTot/1000)*22/1000 
    graph.plot(mph*10)
    ii:=timer.GETTIX
    iii:=timer.getsecs
    iiii:=timer.getmins
    elapsedtix:= ii + (iii*1000) + (iiii*60000)
    elapsedtix:=elapsedtix-temptix
    ii:=timer.GETTIX
    iii:=timer.getsecs
    iiii:=timer.getmins
    temptix:= ii + (iii*1000) + (iiii*60000)

   
  timer.stop
                    

PUB readGforce(pin) | tix,g
 dira[pin]~
 waitpne(|<pin, |< pin, 0)
 waitpeq(|<pin, |< pin, 0)
 tix := cnt
 waitpne(|<pin, |< pin, 0)
 tix :=||(cnt-tix)'/(clkfreq/1_000_000)
 'tix:=tix-levelx
 tix:=(tix*10)/(clkfreq/1000000)
 tix:=tix+levelx
 g:=((tix/100)-500)*8
 return g

PUB calibratex(pin)  | tix
  levelx:=0
  repeat 10
    dira[pin]~
    waitpne(|<pin, |< pin, 0)
    waitpeq(|<pin, |< pin, 0)
    tix := cnt
    waitpne(|<pin, |< pin, 0)
    tix :=||(cnt-tix)
    levelx:=levelx+tix
  levelx:=levelx/10
  levelx:= 50000-((levelx*10)/(clkfreq/1000000))
  return levelx